﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Data.SqlClient;
using System.Web.Services;
using System.Collections.Generic;

public partial class Default : System.Web.UI.Page 
{
    private const int ItemsPerRequest = 10;

    [WebMethod]
    public static RadComboBoxData GetCompanyNames(RadComboBoxContext context)
    {
        DataTable data = GetData(context.Text);

        RadComboBoxData comboData = new RadComboBoxData();
        int itemOffset = context.NumberOfItems;
        int endOffset = Math.Min(itemOffset + ItemsPerRequest, data.Rows.Count);
        comboData.EndOfItems = endOffset == data.Rows.Count;

        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(endOffset - itemOffset);

        for (int i = itemOffset; i < endOffset; i++)
        {
            RadComboBoxItemData itemData = new RadComboBoxItemData();
            itemData.Text = data.Rows[i]["CompanyName"].ToString();
            itemData.Value = data.Rows[i]["CompanyName"].ToString();

            result.Add(itemData);
        }

        comboData.Message = GetStatusMessage(endOffset, data.Rows.Count);

        comboData.Items = result.ToArray();
        return comboData;
    }

    private static string GetStatusMessage(int offset, int total)
    {
        if (total <= 0)
            return "No matches";

        return String.Format("Items <b>1</b>-<b>{0}</b> out of <b>{1}</b>", offset, total);
    }

    private static DataTable GetData(string text)
    {
        SqlDataAdapter adapter = new SqlDataAdapter("SELECT * from Customers WHERE CompanyName LIKE @text + '%'",
             ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        adapter.SelectCommand.Parameters.AddWithValue("@text", text);

        DataTable data = new DataTable();
        adapter.Fill(data);

        return data;
    }

    private static void DisplaySelection(RadComboBox comboBox, Label label)
    {
        if (comboBox.Text != String.Empty)
        {
            label.Text = "You selected text: <b>" + comboBox.Text + "</b> and value: <b>" + comboBox.SelectedValue + "</b>";
        }
        else
        {
            label.Text = "RadComboBox is empty";
        }
    }
}
